code segment 'code'
    assume  CS:code, DS:code
    org 100h

_start:
    jmp _initTSR                                ;   

    ignoredChars                DB 'abcdefghijklmnopqrstuvwxyz' ;  
    ignoredLength               DB 26           ;   ignoredChars
    ignoreEnabled               DB true         ;    
    translateFrom               DB 'F<DUL'     ;  
    translateTo                 DB ''     ; ,     
    translateLength             DB 6            ;   translateFrom
    translateEnabled            DB true            ;   
    
    signaturePrintingEnabled    DB true            ;   
    counter                     DW 0
    printDelay                  EQU 3           ;    ""  
    
    signatureLineLength         DW  52          ;    
    signatureLine1              DB  179, '                         ', 179
    signatureLine2              DB  179, '5-43                                            ', 179
    signatureLine3              DB  179, ' 16                                        ', 179
    tableTop                    DB  '-', 50 dup ('-'), ''
    tableBottom                 DB  'L', 50 dup ('-'), '-'

    helpMsg     DB '> kr.com [/?] [/u]', 10, 13
                DB ' [/?] -   ', 10, 13
                DB ' [/u] -    ', 10, 13
                DB '  F4  -         ', 10, 13
                DB '  F5  - /     ', 10, 13
                DB '  F6  - /   : F<DUL -> ', 10, 13
                DB '  F7  - /     abcdefghijklmnopqrstuvwxyz', 10, 13, 0
            
    helpMsgLength               EQU $-helpMsg
    commandLineResult           DB 0
    
    cursiveEnabled              DB 0            ;     
    cursiveSymbol               DB 00000000b    ; ,    (  )
                                DB 00000000b
                                DB 00000000b
                                DB 10000010b 
                                DB 10000010b 
                                DB 10000010b 
                                DB 10000010b 
                                DB 11111110b 
                                DB 10000010b 
                                DB 10000010b 
                                DB 10000010b 
                                DB 10000010b 
                                DB 00000000b
                                DB 00000000b
                                DB 00000000b
                                DB 00000000b
    
    charToCursiveIndex          DB ''          ;   
    savedSymbol                 DB 16 dup(0FFh) ;     

    old_int9hOffset             DW  ?           ;    int 9h
    old_int9hSegment            DW  ?           ;    int 9h
    old_int1ChOffset            DW  ?           ;    int 1Ch
    old_int1ChSegment           DW  ?           ;    int 1Ch
    old_int2FhOffset            DW  ?           ;    int 2Fh
    old_int2FhSegment           DW  ?           ;    int 2Fh

    installedMsg                DB  ' .', 0
    alreadyInstalledMsg         DB  '   .', 0
    notInstalledMsg             DB  '   .$'

    removedMsg                  DB  '   .'
    removedMsg_length           EQU $-removedMsg

    noRemoveMsg                 DB  '   '
    noRemoveMsg_length          EQU $-noRemoveMsg

    true                        EQU 0FFh        ;     not  
                                                ; 0FFh = 11111111b =  00000000b

    ;    int 9h
    ; (  )
    new_int9h proc far
        push SI AX BX CX DX ES DS               ;   ,    
        push CS                                 ;  CS  DS
        pop DS

        pushf
        call dword ptr CS:[old_int9hOffset]     ;    
        mov AX, 40h                             ; 40h - ,     
        mov ES, AX
        mov BX, ES:[1Ch]                        ;  
        sub BX, 2h                              ;      
        cmp BX, 1Eh                             ;       ?
        jae _go
        mov BX, 3Ch                             ;     : , 
                                                ;      
    _go:        
        mov DX, ES:[BX]                         ;  DX 0  
 
    _test_Fx:                                   ;  F4-F8
	_F4:
        cmp DH, 3Eh                             ; F4
        jne _F4
        not signaturePrintingEnabled
        mov ES:[1Ch], BX                        ;   
        jmp _quit

    _F5:
        cmp DH, 3Fh                             ; F5
        jne _F6
        not cursiveEnabled ;      
        call toggleCursive     ;     cursiveEnabled
        jmp _quit
    _F6:
        cmp DH, 40h                             ; F6
        jne _F7
        not translateEnabled
        mov ES:[1Ch], BX                        ;                  
        jmp _quit
    _F7:
        cmp DH, 41h                             ; F7
        jne _translateOrIgnore
        not ignoreEnabled
        mov ES:[1Ch], BX                        ;   
        jmp _quit

    _translateOrIgnore:                         ;      
        cmp ignoreEnabled, true                 ;     ?
        jne _checkTranslate            
        
        mov SI, 0                               ; , 
        mov CL, ignoredLength                   ;   
        
    _checkIgnored:
        cmp DL, ignoredChars[SI]                ; ,       
        je _block
        inc SI
        loop _checkIgnored                      ;  ignoredLength 
        jmp _checkTranslate
        
    ; 
    _block:
        mov ES:[1Ch], BX                        ;   
        jmp _quit
    
    _checkTranslate:
        cmp translateEnabled, true              ;    ?
        jne _quit
        
        mov SI, 0                               ; , 
        mov CL, translateLength                 ; -   
    
    _checkTranslateLoop:
        cmp DL, translateFrom[SI]               ;        ?
        je _translate                      
        inc SI
        loop _checkTranslateLoop                ; ,      
        jmp _quit
        
    _translate:     
        xor AX, AX                              ; 
        mov AL, translateTo[SI]
        mov ES:[BX], AX                         ;  

    _quit:
        pop DS ES DX CX BX AX SI                ;   
        iret
    new_int9h endp

    ;     cursiveEnabled       
    ;      changeFont -    
    toggleCursive proc
        push ES AX                              ;  
        push CS
        pop ES

        cmp cursiveEnabled, true                ;    true,
        jne _restoreSymbol                      ;      ,
                                                ;      savedSymbol
        
        call saveFont
        mov CL, charToCursiveIndex
    _shiftTable:
        add BP, 16                              ;   BP   .     0
                                                ;     16*X -  X -  
        loop _shiftTable 

        push DS                                 ; p savefont  pp ES                            
        pop AX                                  ; y p   ,  
        push ES                                 ;  y   savedSymbol
        pop DS                                  
        push AX                                 ; DS -> AX, ES -> DS, AX -> ES => ES  DS  
        pop ES                                  ; +    DS  AX
        push AX

        mov SI, BP
        lea DI, savedSymbol                     ; p  py savedSymbol   
        
        mov CX, 16                              ; movsb  DS:SI  ES:DI
        
        rep movsb                               ;    p 
        pop DS                                  ;  DS

        mov CX, 1                               ;     yp
        mov DH, 0
        mov DL, charToCursiveIndex
        lea BP, cursiveSymbol
        call changeFont
        jmp _exitToggleCursive
        
    _restoreSymbol: 
        mov CX, 1                               ;    0,      
        mov DH, 0
        mov DL, charToCursiveIndex
        lea BP, savedSymbol
        call changeFont
        
    _exitToggleCursive:
        pop AX
        pop ES
        ret
    toggleCursive endp 
    
    ;     (/)
    ;
    ;  :
    ; 1) DL =    
    ; 2) CX =     
    ;    (     DX)
    ; 3) ES:BP =  
    ;
    ;   :
    ; 1)   int 10h ()
    ;      AH = 11h ( )
    ;     AL = 0 ,    
    ;       .
    ;     ,  AL = 1  2,   
    ;        (8x14  8x8 )
    ; 2)  BH = 0Eh ,      
    ;      14  ( 8x14    14 )
    ; 3)  BL = 0 -     ( 0  4)
    ;
    ; :
    ;  () ()  
    ;   .
    ;    ,   :
    ;  ,   ,      
    changeFont proc
        push AX BX DX
        mov AX, 1100h
        mov BX, 1000h
        int 10h
        pop DX BX AX
        ret
    changeFont endp

    ;     
    ;
    ;  :
    ; BH -    
    ;   = 0     -   int 1fh
    ;   = 1     -   int 44h
    ;   = 2..5  -   8x14, 8x8, 8x8 (top), 9x14
    ;   = 6     - 8x16
    ;
    ;   :
    ;     int 10h ()
    ;     AH = 11h ( )
    ;    AL = 30 -     EGA
    ;
    ; :
    ;   1)  ES:BP    ()
    ;   2)  CX    
    ;   3)  DL   
    ; !    ES (ES = C000h)
    saveFont proc
        push AX BX DX
        mov AX, 1130h
        mov BX, 0600h
        int 10h
        pop BX AX DX
        ret
    saveFont endp

    ;   int 2Fh
    ;  :
    ;  1)    TSR   ( AH=0FFh, AL=0)
    ;       AH='i'  ,  TSR  
    ;  2)  TSR   ( AH=0FFh, AL=1)
    new_int2Fh proc
        cmp AH, 0FFh                            ;  ?
        jne _2Fh_default                        ;  -   
        cmp AL, 0                               ;  ,     ?
        je  _alreadyInstalled2Fh
        cmp AL, 1                               ;    ?
        je  _uninstall
        jmp _2Fh_default

    _2Fh_default:
        jmp dword ptr CS:[old_int2FhOffset]     ;   

    _alreadyInstalled2Fh:
        mov AH, 'i'                             ;  AH = 'i',      
        iret                                    ; ,  'i'    

    _uninstall:                                 ;    
        push DS ES DX BX
        xor BX, BX

        push CS                                 ; CS = ES,    
        pop ES

        mov AX, 2509h
        mov DX, ES:old_int9hOffset              ;    09h  
        mov DS, ES:old_int9hSegment
        int 21h

        mov AX, 251Ch
        mov DX, ES:old_int1ChOffset             ;    1Ch  
        mov DS, ES:old_int1ChSegment
        int 21h

        mov AX, 252Fh
        mov DX, ES:old_int2FhOffset             ;    2Fh  
        mov DS, ES:old_int2FhSegment
        int 21h

        mov ES, CS:2Ch                          ;   ES  
        mov AH, 49h                             ;    
        int 21h
        jc _notRemove

        push CS
        pop ES                                  ;  ES -   
        mov AH, 49h                             ;    
        int 21h

        jc _notRemove
        jmp _unloaded

    _notRemove:                                 ;     =>  
        mov AH, 03h                             ;   
        int 10h
        lea BP, noRemoveMsg
        mov CX, noRemoveMsg_length
        mov BL, 0111b
        mov AX, 1301h
        int 10h
        jmp _2Fh_exit

    _unloaded:                                  ;    =>  
        mov AH, 03h                             ;   
        int 10h
        lea BP, removedMsg
        mov CX, removedMsg_length
        mov BL, 0111b
        mov AX, 1301h
        int 10h

    _2Fh_exit:
        pop BX DX ES DS
        iret
    new_int2Fh endp

    ;   int 1Ch
    ;   55 
    new_int1Ch proc far
        push AX
        push CS
        pop DS
        
        pushf
        call dword ptr CS:[old_int1ChOffset]    ;    
        
        cmp signaturePrintingEnabled, true      ;     (   F4)
        jne _notToPrint     
        
        cmp counter, printDelay*1000/55 + 1     ;  - ""  printDelay 
        je _letsPrint
        
        jmp _dontPrint
        
    _letsPrint:
        not signaturePrintingEnabled
        mov counter, 0
        call printSignature                     ;    
        
    _dontPrint:
            inc counter                         ;     1
            
    _notToPrint:
        pop AX
        iret
    new_int1Ch endp

    ;    
    printSignatureLine proc
        push DX
        mov CX, signatureLineLength     
        mov BL, 0111b                           ;   
        mov AX, 1301h                           ; AH = 13h -  -, AL = 01h -  
        int 10h
        pop DX
        inc DH
        ret
    printSignatureLine endp

    ;   
    printSignature proc
        push AX DX CX BX ES SP BP SI DI

        xor AX, AX                              ;   
        xor BX, BX
        xor DX, DX
        
        mov AH, 03h                             ;    
        int 10h
        push DX                                 ;       
        
        mov DX, 000Fh                           ; NB! : 000Fh, : 090Fh, : 130Fh
            
    _actualPrint:   
        mov AH, 0Fh                             ;   .  BH -  
        int 10h

        push CS                     
        pop ES                                  ;  ES  CS
        
        lea BP, tableTop                        
        call printSignatureLine                 ;   
        lea BP, signatureLine1          
        call printSignatureLine                 ;   
        lea BP, signatureLine2
        call printSignatureLine                 ;   
        lea BP, signatureLine3
        call printSignatureLine                 ;   
        lea BP, tableBottom 
        call printSignatureLine                 ;   
        
        xor BX, BX
        pop DX                                  ;      
        mov AH, 02h                             ;     
        int 10h
            
        pop DI SI BP SP ES BX CX DX AX
        ret
    printSignature endp

    ;   
    ; 1)  
    ; 2) ,   
    ; 3)   
    _initTSR:
        mov AH, 03h
        int 10h
        push DX
        mov AH, 00h                             ;  
        mov AL, 83h
        int 10h
        pop DX
        mov AH, 02h
        int 10h

        call commandParamsParser                ;    
        cmp commandLineResult, 2                ;   = 2,    
        jne _shouldContinue                     ; ,      
        jmp _exit   
    _shouldContinue:
        cmp commandLineResult, 1                ;    
        jne _go_on
        mov AH, 0FFh
        mov AL, 0
        int 2Fh
        cmp AH, 'i'                             ;  ,    
        je _remove
 
        mov AH, 09h
        lea DX, notInstalledMsg                 ;   
        int 21h
        int 20h
    _go_on:
        mov AH, 0FFh                            ;  ,    
        mov AL, 0
        int 2Fh
        cmp AH, 'i'                             ;  ,  AH = 'i' (.  new_int2Fh)
        je _alreadyInstalled

        mov AX, 3509h                           ;   ES:BX  09h
        int 21h
        mov word ptr CS:old_int9hOffset, BX     ;   09h
        mov word ptr CS:old_int9hSegment, ES
        mov AX, 2509h                           ;     09h
        mov DX, offset new_int9h
        int 21h

        mov AX, 351Ch                           ;   ES:BX  1Ch
        int 21h
        mov word ptr CS:old_int1ChOffset, BX    ;   1Ch
        mov word ptr CS:old_int1ChSegment, ES
        mov AX, 251Ch                           ;     1Ch
        mov DX, offset new_int1Ch
        int 21h

        mov AX, 352Fh                           ;   ES:BX  2Fh
        int 21h
        mov word ptr CS:old_int2FhOffset, BX    ;   2Fh
        mov word ptr CS:old_int2FhSegment, ES
        mov AX, 252Fh                           ;     2Fh
        mov DX, offset new_int2Fh
        int 21h

        lea BX, installedMsg                    ;  ,   
        call printStr

        mov DX, offset _initTSR                 ;        
        int 27h

    _remove:                                    ;   
        push ES
        mov AX, DS:[2Ch]                        ; PSP
        mov ES, AX
        mov AH, 49h                             ;     ?
        int 21h
        pop ES

        mov AH, 0FFh
        mov AL, 1
        int 2Fh
        jmp _exit
    _alreadyInstalled:                          ;   
        lea BX, alreadyInstalledMsg
        call printStr
        jmp _exit
    _exit:                                      ; 
        int 20h

    ;    .  .
    ;   commandLineResult: 
    ; 0 =  ; 1 =  ; 2 =   ,    
    commandParamsParser proc
        push CS
        pop ES

        mov SI, 80h                             ; SI =   
        lodsb                                   ;  - 
        or AL, AL                               ;  0  ,
        jz _paramParsingEnd                     ;    
 
    _nextChar:
        inc SI                                  ;  SI     
 
        cmp [SI], BYTE ptr 0
        je _paramParsingEnd
 
        lodsw                                   ;   
        cmp AX, '?/'
        je _displayHelp
        cmp AX, 'u/'
        je _finishTSR
        cmp AX, 'U/'
        je _finishTSR
        jmp _nextChar
 
    _finishTSR:
        mov commandLineResult, 1                ;  ,    
        jmp _nextChar

        jmp _paramParsingEnd
    _displayHelp:
        lea BX, helpMsg                         ;  
        call printStr
        mov commandLineResult, 2                ;  ,     

    _paramParsingEnd:
        ret
   commandParamsParser endp

    ;    AL
    printChar proc
        mov AH, 0EH
        int 010H
        ret
    printChar endp

    ;  -   [BX]
    printStr proc
        push DX AX
        mov AX, [BX]
    _printStrLoop:
        cmp AL, 0
        je _printStrEnd
        call printChar
        inc BX
        mov AX, [BX]
        jmp _printStrLoop
    _printStrEnd:
        pop AX DX
        ret
    printStr endp

code ends
end _start